Loading...
Searching...
No Matches
Dfs< GR, TR >::SetDistMap< T > Struct Template Reference

## Detailed Description

template<typename GR, typename TR>
template<class T>
struct lemon::Dfs< GR, TR >::SetDistMap< T >

`DistMap` type. Named parameter for setting `DistMap` type. It must conform to the WriteMap concept.

`#include <lemon/dfs.h>`

Inheritance diagram for Dfs< GR, TR >::SetDistMap< T >:
[legend]

## Additional Inherited Members

Public Types inherited from Dfs< Digraph, SetDistMapTraits< T > >
typedef SetDistMapTraits< T >::Digraph | Digraph
| The type of the digraph the algorithm runs on.
typedef SetDistMapTraits< T >::PredMap | PredMap
| The type of the map that stores the predecessor arcs of the DFS paths.
typedef SetDistMapTraits< T >::DistMap | DistMap
| The type of the map that stores the distances of the nodes.
typedef SetDistMapTraits< T >::ReachedMap | ReachedMap
| The type of the map that indicates which nodes are reached.
typedef SetDistMapTraits< T >::ProcessedMap | ProcessedMap
| The type of the map that indicates which nodes are processed.
typedef PredMapPath< Digraph, PredMap > | Path
| The type of the paths.
typedef SetDistMapTraits< T > | Traits
| The traits class of the algorithm.
Public Member Functions inherited from Dfs< Digraph, SetDistMapTraits< T > >
| Dfs (const Digraph &g)
| Constructor.
| ~Dfs ()
| Destructor.
Dfs & | predMap (PredMap &m)
| Sets the map that stores the predecessor arcs.
Dfs & | reachedMap (ReachedMap &m)
| Sets the map that indicates which nodes are reached.
Dfs & | processedMap (ProcessedMap &m)
| Sets the map that indicates which nodes are processed.
Dfs & | distMap (DistMap &m)
| Sets the map that stores the distances of the nodes.
void | init ()
| Initializes the internal data structures.
void | addSource (Node s)
| Adds a new source node.
Arc | processNextArc ()
| Processes the next arc.
OutArcIt | nextArc () const
| Next arc to be processed.
bool | emptyQueue () const
| Returns `false` if there are nodes to be processed.
int | queueSize () const
| Returns the number of the nodes to be processed.
void | start ()
| Executes the algorithm.
void | start (Node t)
| Executes the algorithm until the given target node is reached.
Arc | start (const ArcBoolMap &am)
| Executes the algorithm until a condition is met.
void | run (Node s)
| Runs the algorithm from the given source node.
bool | run (Node s, Node t)
| Finds the DFS path between `s` and `t`.
void | run ()
| Runs the algorithm to visit all nodes in the digraph.
Path | path (Node t) const
| The DFS path to the given node.
int | dist (Node v) const
| The distance of the given node from the root(s).
Arc | predArc (Node v) const
| Returns the 'previous arc' of the DFS tree for the given node.
Node | predNode (Node v) const
| Returns the 'previous node' of the DFS tree for the given node.
const DistMap & | distMap () const
| Returns a const reference to the node map that stores the distances of the nodes.
const PredMap & | predMap () const
| Returns a const reference to the node map that stores the predecessor arcs.
bool | reached (Node v) const
| Checks if the given node. node is reached from the root(s).